/*
 * Assertion.java
 *
 * Created on February 18, 2002, 9:29 AM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * The abstract superclass of all DL assertions.
 * @author  Michael Sintek
 * @version 
 */
public abstract class Assertion {
  
  // modes when walking through expressions
  static final int CONCEPT = 0;
  static final int ROLE = 1;
  
  public void print(Syntax syntax, PrintWriter out) {
    out.println("(print not overwritten: " + this.toString() + ")");
  }
  
  public void toSHIQ(KB kb) {
    System.err.println("toSHIQ not overwritten: " + this.toString());
    kb.add(this);
  }
  
}
