/*
 * AtMost.java
 *
 * Created on February 18, 2002, 2:54 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * AtMost (qualified and unqualified)
 * @author  Michael Sintek
 * @version 
 */
public class AtMost extends Expression {

  Expression _expr1, _expr2;
  int _card;
  
  /** Creates new AtMost */
  public AtMost(int card, Expression expr1) {
    _card = card;
    _expr1 = expr1;
    _expr2 = Symbol.TOP;
  }
  
  public AtMost(int card, Expression expr1, Expression expr2) {
    _card = card;
    _expr1 = expr1;
    _expr2 = expr2;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML()) {
      out.print ("<ATMOST NUM=\"" + _card + "\">");
      _expr1.print (syntax, out);
      _expr2.print (syntax, out);
      out.print ("</ATMOST>");
    } else {
      out.print ("(at_most " + _card + " ");
      _expr1.print (syntax, out);
      out.print (" ");
      _expr2.print (syntax, out);
      out.print (")");
    }
  }
  
  public Expression toSHIQ(KB kb, int mode) {
    return new AtMost(_card, _expr1.toSHIQ(kb, ROLE), _expr2.toSHIQ(kb, CONCEPT));
  }

}
