/*
 * Expression.java
 *
 * Created on February 18, 2002, 9:28 AM
 */

package org.semanticweb.dl;

import java.util.*;
import java.io.*;


/**
 * The abstract superclass of all DL expressions.
 * @author  Michael Sintek
 * @version 
 */
public abstract class Expression {

  // modes when walking through expressions
  static final int CONCEPT = 0;
  static final int ROLE = 1;
  
  public void print(Syntax syntax, PrintWriter out) {
    // should we change this according to syntax?
    out.print("(print not overwritten: " + this.toString() + ")");
  }
  
  public String toString() {
    return toString(new Syntax(new KB())); // new KB is ugly but works!
  }
  
  public String toString(Syntax syntax) {
    StringWriter stringWriter = new StringWriter();
    PrintWriter out = new PrintWriter(stringWriter);
    print(syntax, out);
    out.close();
    return stringWriter.toString();
  }
  
  public Expression toSHIQ(KB kb, int mode) {
    System.err.println("toSHIQ not overwritten: " + this.toString());
    return this;
  }
  
  // auxiliaries for expressions
  
  public void printSequence(ArrayList list, Syntax syntax, PrintWriter out) {
    for (Iterator iter = list.iterator(); iter.hasNext();) {
      ((Expression)iter.next()).print(syntax, out);
      if (!syntax.XML() && iter.hasNext())
        out.print(" ");
    }
  }
    
}
