/*
 * ImpliesR.java
 *
 * Created on February 18, 2002, 5:10 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * ImpliesR assertion (for roles).
 * @author  Michael Sintek
 * @version 
 */
public class ImpliesR extends Assertion {

  Expression _expr1, _expr2;
  
  /** Creates new ImpliesR */
  public ImpliesR(Expression expr1, Expression expr2) {
    _expr1 = expr1;
    _expr2 = expr2;
  }
  
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<IMPLIESR>");
      out.print ("<ROLE>");
      _expr1.print (syntax, out);
      out.print ("</ROLE>");
      out.print ("<ROLE>");
      _expr2.print (syntax, out);
      out.print ("</ROLE>");
      out.println ("</IMPLIESR>");
    } else {
      out.print ("(implies_r ");
      _expr1.print (syntax, out);
      out.print (" ");
      _expr2.print (syntax, out);
      out.println (")");
    }
  }
  
  public void toSHIQ(KB kb) {
    kb.add(new ImpliesR(_expr1.toSHIQ(kb, ROLE), _expr2.toSHIQ(kb, ROLE)));
  }

}
