/*
 * Or.java
 *
 * Created on February 18, 2002, 1:47 PM
 */

package org.semanticweb.dl;

import java.util.*;
import java.io.*;


/**
 * Or = union.
 * @author  Michael Sintek
 * @version 
 */
public class Or extends Expression {

  ArrayList _expressions; // of Expression
  
  /** Creates new Or */
  public Or(ArrayList expressions) { // dont' call with empty list!
    _expressions = expressions;
  }
  
  public static Expression getOr(Expression expr) {
    if (expr instanceof Or)
      return expr;
    else { // normalize ...
      ArrayList expressions = new ArrayList();
      expressions.add(expr);
      return new Or(expressions);
    }
  }
  
  public static Expression getOr(ArrayList list) {
    return getOr(list, Symbol.TOP);
  }
  
  public static Expression getOr(ArrayList list, Expression def) {
    if (list.size() == 0)
      return def;
    else if (list.size() == 1)
      return (Expression)list.iterator().next();
    else
      return new Or(list);
  }
    
  public void print(Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<OR>");
      printSequence (_expressions, syntax, out);
      out.print ("</OR>");
    } else {
      out.print ("(or ");
      printSequence (_expressions, syntax, out);
      out.print (")");
    }
  }
  
  public Expression toSHIQ(KB kb, int mode) {
    ArrayList list = new ArrayList();
    for (Iterator iter = _expressions.iterator(); iter.hasNext();)
      list.add(((Expression)iter.next()).toSHIQ(kb, CONCEPT));
    return getOr(list);
  }

}
