/*
 * Transitive.java
 *
 * Created on February 18, 2002, 5:10 PM
 */

package org.semanticweb.dl;

import java.io.*;


/**
 * Transitive assertion (for roles).
 * @author  Michael Sintek
 * @version 
 */
public class Transitive extends Assertion {

  Expression _expr;
  
  /** Creates new Transitive */
  public Transitive(Expression expr) {
    _expr = expr;
  }
  
  public void print (Syntax syntax, PrintWriter out) {
    if (syntax.XML ()) {
      out.print ("<TRANSITIVE>");
      out.print ("<ROLE>");
      _expr.print (syntax, out);
      out.print ("</ROLE>");
      out.println ("</TRANSITIVE>");
    } else {
      out.print ("(transitive ");
      _expr.print (syntax, out);
      out.println (")");
    }
  }
  
  public void toSHIQ(KB kb) {
    // is directly supported in SHIQ
    kb.add(new Transitive(_expr.toSHIQ(kb, ROLE)));
  }

}
