package org.semanticweb.triple.inference;

/**
 *  Copyright  Juergen Angele and Stefan Decker, Institut AIFB, University of
 *  Karlsruhe. All Rights Reserved.
 *
 *@author     Administrator
 *@created    January 17, 2002
 */

/*
 *  Name: BuiltinBody.java
 *  Version: 1.0
 *  Purpose: represents rule bodies using builtins
 *  History:
 */
public class BuiltinBody extends Body {
    /**
     *  Description of the Field
     */
    protected BuiltinFunc func;


    /**
     *  Constructor for the BuiltinBody object
     *
     *@param  sym      Description of the Parameter
     *@param  negated  Description of the Parameter
     *@param  terms    Description of the Parameter
     *@param  f        Description of the Parameter
     */
    public BuiltinBody(int sym, boolean negated, Term[] terms, BuiltinFunc f) {
        super(sym, negated, terms);
        builtin = true;
        func = f;
    }


    /**
     *  Description of the Method
     */
    public void Eval() {
        up.Eval(this, adddown, vars3, func);
        addup.UnionSelected(up);
    }


    /**
     *  Description of the Method
     *
     *@param  t  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean Evaluable(Atom t) {
        return func.isevaluable(this, t);
    }


    /**
     *  Description of the Method
     *
     *@param  brel   Description of the Parameter
     *@param  index  Description of the Parameter
     *@return        Description of the Return Value
     */
    public boolean NaiveRight(Atoms brel, int index[]) {
        int oldnum;
        int newnum;
        oldnum = brelation.anztuples;
        down.Substitute(this, brel, bindex);
        up.Eval(this, down, vars3, func);
        if (!neg) {
            // Join mit positivem Rumpfliteral
            brelation.Join(brel, index, up, index1, brel.matchindex, dindex);
        }
        else {
            // Differenz mit negativem Rumpfliteral
            brelation.Negation(brel, index, up, index1);
        }
        newnum = brelation.anztuples;
        return oldnum != newnum;
    }
}
