package org.semanticweb.triple.inference;

/*
 *  Copyright  Juergen Angele and Stefan Decker,
 *  Institut AIFB, University of Karlsruhe.
 *  All Rights Reserved.
 *
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class CompareAtoms implements Comparison {
    int index1[] = null;
    int index2[] = null;


    /**
     *  The constructor of the CompareAtoms class. I don't see for what the
     *  indices are good for.
     *
     *@param  ix1
     *@param  ix2
     */

    public CompareAtoms(int ix1[], int ix2[]) {
        index1 = ix1;
        index2 = ix2;
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     *@return     Description of the Return Value
     */
    protected int cmp(Term t1, Term t2) {
        int i;
        int res = 0;
        if (t1.ground && t2.ground) {
            res = t1.Compare(t2);
        }
        else
                if ((t1 instanceof Variable) || (t2 instanceof Variable)) {
            res = 2;
        }
        else {
            if ((t1.type() != t2.type()) || (t1.anzpars() != t2.anzpars())) {
                res = t1.CompareTypes(t2);
            }
            else {
                res = t1.CompareFlat(t2);
                if (res == 0) {
                    for (i = 0; (i < t1.anzpars()) && (res == 0); i++) {
                        res = cmp(t1.pars[i], t2.pars[i]);
                    }
                    if (res == 2) {
                        for (; (i < t1.anzpars()) && ((res == 2) || (res == 0)); i++) {
                            res = cmp(t1.pars[i], t2.pars[i]);
                        }
                        if ((res == 2) || (res == 0)) {
                            return 2;
                        }
                        else {
                            return -2;
                        }
                    }
                    else {
                        return res;
                    }
                }
            }
        }
        return res;
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     *@return     Description of the Return Value
     */
    public int Compare(Object t1, Object t2) {
        int i = 0;
        int res = 0;
        for (i = 0; (index1[i] != -1) && (res == 0); i++) {
            res = cmp(((GroundAtom) t1).terms[index1[i]], ((GroundAtom) t2).terms[index2[i]]);
        }
        if (res == 2) {
            for (; (index1[i] != -1) && ((res == 2) || (res == 0)); i++) {
                res = cmp(((GroundAtom) t1).terms[index1[i]], ((GroundAtom) t2).terms[index2[i]]);
            }
            if ((res == 2) || (res == 0)) {
                res = 2;
            }
            else {
                res = -2;
            }
        }
        /*
         *  printatom((GroundAtom)t1,index1); System.out.print(" ");
         *  printatom((GroundAtom)t2,index2); System.out.print(" ");
         *  System.out.println(res);
         */
        return res;
    }


    /**
     *  Description of the Method
     *
     *@param  t   Description of the Parameter
     *@param  ix  Description of the Parameter
     */
    public void printatom(GroundAtom t, int ix[]) {
        int i;
        for (i = 0; (i < ix.length) && (ix[i] != -1); i++) {
            System.out.print(t.terms[ix[i]].toString());
            if ((i < ix.length - 1) && (ix[i + 1] != -1)) {
                System.out.print(",");
            }
        }
    }
}
