package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class Generalization extends Operation {
    /**
     *  Constructor for the Generalization object
     *
     *@param  R1   Description of the Parameter
     *@param  ix1  Description of the Parameter
     *@param  R2   Description of the Parameter
     *@param  ix2  Description of the Parameter
     *@param  D    Description of the Parameter
     *@param  T    Description of the Parameter
     */
    public Generalization(Atoms R1, int ix1[], Atoms R2, int ix2[], Atoms D, long T) {
        super(R1, ix1, R2, ix2, T);
        this.D = D;
        D.tuples2 = null;
        comp1 = new CompareAtoms(ix1, ix2);
        comp2 = new CompareAtoms(ix2, ix1);
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     */
    public void op(GroundAtom t1, GroundAtom t2) {
        // int i;
        Atom t;
        // int i;
        Atom ins;
        // Variable v;
        Atom t1n = (Atom) t1;
        Atom t2n = (Atom) t2;
        if (t1n != t2n) {
            t = t1n.Generalize(t2n);
            if (t != null) {
                ins = (Atom) D.Insert(t);
                if (ins == t) {
                    t.next2 = D.tuples2;
                    D.tuples2 = t;
                }
                if (t1n.lasttouched < timestamp) {
                    t1n.next2 = R1.tuples2;
                    R1.tuples2 = t1n;
                    t1n.lasttouched = timestamp;
                }
                if (t2n.lasttouched < timestamp) {
                    t2n.next2 = R2.tuples2;
                    R2.tuples2 = t2n;
                    t2n.lasttouched = timestamp;
                }
            }
        }
    }
}
