package org.semanticweb.triple.inference;

/*
 *  Name: IndexEnumeration.java
 *  Version: 1.1
 *  Purpose: Interface for enumerating elements of an index (see IndexInterface)
 *  History:
 */
import java.util.NoSuchElementException;

/**
 *  Description of the Interface
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public interface IndexEnumeration {

    /**
     *  Delivers a clone of the Enumeration and by this way stores the internal
     *  state
     *
     *@return    Description of the Return Value
     */
    public Object clone();


    /**
     *  Are there more elements available?
     *
     *@return    Description of the Return Value
     */
    public boolean hasMoreElements();


    /**
     *  Give the next element. Throws NoSuchElementException if no further
     *  element is available. Equal elements appear in one sequence
     *
     *@return                             Description of the Return Value
     *@exception  NoSuchElementException  Description of the Exception
     */
    public Object nextElement() throws NoSuchElementException;


    /**
     *  Give the first next element greater or equal than o. Returns null if no
     *  greater element is available
     *
     *@param  o                           Description of the Parameter
     *@return                             Description of the Return Value
     *@exception  NoSuchElementException  Description of the Exception
     */
    public Object nextGreaterElement(Object o) throws NoSuchElementException;


    /**
     *  Position enumeration to the first element equal to o or if it does not
     *  exist to the next existing element
     *
     *@param  o  Description of the Parameter
     */
    public void positionToElement(Object o);


    /**
     *  Description of the Method
     */
    public void print();


    /**
     *  Indrocues a new comparison method for the next method nextGreaterElement
     *
     *@param  c  The new comparisonMethod value
     */
    public void setComparisonMethod(Comparison c);
}
