package org.semanticweb.triple.inference;

/*
 *  Name: Atoms.java
 *  Version: 2.0
 *  Purpose: a container for atoms with appropriate access data structures
 *  (AVL trees)
 *  History:
 */
import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
class MatchNegation extends Operation {
    /**
     *  Constructor for the MatchNegation object
     *
     *@param  R1   Description of the Parameter
     *@param  ix1  Description of the Parameter
     *@param  R2   Description of the Parameter
     *@param  ix2  Description of the Parameter
     *@param  T    Description of the Parameter
     */
    public MatchNegation(Atoms R1, int ix1[], Atoms R2, int ix2[], long T) {
        super(R1, ix1, R2, ix2, T);
        comp1 = new CompareAtoms(ix1, ix2);
        comp2 = new CompareAtoms(ix2, ix1);
    }


    /**
     *  Description of the Method
     *
     *@param  t1  Description of the Parameter
     *@param  t2  Description of the Parameter
     */
    public void op(GroundAtom t1, GroundAtom t2) {
        int i;
        boolean res = true;
        Atom t = (Atom) t1;
        if (t.variables == null) {
            t.Variables();
        }
        for (i = 0; index1[i] != -1; i++) {
            res = t.terms[index1[i]].Match((t2).terms[index2[i]]);
        }
        if (res) {
            if (t.lasttouched < timestamp) {
                t.next2 = R1.tuples2;
                R1.tuples2 = t;
                t.lasttouched = timestamp;
            }
            if (t2.lasttouched < timestamp) {
                t2.next2 = R2.tuples2;
                R2.tuples2 = t2;
                t2.lasttouched = timestamp;
            }
        }
        t.ClearVariables();
    }
}
