package org.semanticweb.triple.inference;

/*
 *  Name: SParser.java
 *  Version: 1.02
 *  Purpose: Parsing of the internal file format
 *  History:
 *  /6.5.99 Added support for new builtin mechanism. JAn
 *  22.6.99 bug in decode eliminated (jan)
 */
import java.util.Date;
import java.util.Random;
import java.lang.Long;
import java.io.*;
import java.util.*;
import java.net.*;
import org.semanticweb.triple.inference.builtins.BuiltinConfig;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class SParser extends Object {
    BuiltinConfig builtins = null;
    char[] text;
    int index = 0;
    /**
     *  Description of the Field
     */
    public boolean show = false;


    /**
     *  Constructor for the SParser object
     *
     *@param  builtns  Description of the Parameter
     */
    public SParser(BuiltinConfig builtns) {
        index = 0;
        builtins = builtns;
    }


    /**
     *  Constructor for the SParser object
     *
     *@param  s        Description of the Parameter
     *@param  builtns  Description of the Parameter
     */
    public SParser(String s, BuiltinConfig builtns) {
        builtins = builtns;
        index = 0;
        text = (s + "\0").toCharArray();
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    Atom atom() throws SParseError {
        int len;
        int i;
        Atom a;
        Term ts[];
        index++;
        len = number();
        ts = new Term[len];
        for (i = 0; i < len; i++) {
            ts[i] = term();
        }
        a = new Atom(ts);
        return a;
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    Body body() throws SParseError {
        Atom a;
        Body b;
        int maxbuiltin;
        int sym;
        boolean neg = false;
        if (text[index] == '-') {
            neg = true;
            index++;
        }
        index++;
        sym = number();
        a = atom();

        /*
         *  if ((builtins != null) && (0 <= (maxbuiltin = builtins.getBuiltinNumber())) && (sym<maxbuiltin)) {
         *  System.out.println(sym);
         *  b = new BuiltinBody(sym, neg, a.terms, builtins.newInstance(sym));
         *  }
         *  else
         */
        b = new Body(sym, neg, a.terms);
        return b;
    }


    /**
     *  Description of the Method
     *
     *@param  rs               Description of the Parameter
     *@param  db               Description of the Parameter
     *@param  s                Description of the Parameter
     *@exception  SParseError  Description of the Exception
     */
    public void decode(RuleSet rs, DB db, String s) throws SParseError {
        Rule r;
        // Atom a;
        Fact f;
        index = 0;
        text = (s + "\0").toCharArray();

        switch (text[0]) {
            case 'l':
                r = rule();
                if (show) {
                    System.out.println(r.toString());
                }
                else if (rs != null) {
                    rs.AddRule(r);
                }
                break;
            case 'p':
                f = fact();
                if (show) {
                    System.out.print(f.toString());
                    System.out.println();
                }
                else if (rs != null) {
                    db.AddFact(f.symbol, new GroundAtom(f.terms));
                }
                break;
            /*
             *  case 'x':
             *  r = xrule();
             *  if (show) {System.out.println(r.toString());}
             *  else if (rs != null) rs.AddBaseRule(r);
             *  break;
             */
        }
    }


    /**
     *  Description of the Method
     *
     *@param  rs               Description of the Parameter
     *@param  s                Description of the Parameter
     *@exception  SParseError  Description of the Exception
     */
    public void decode(RuleSet rs, String s) throws SParseError {
        Rule r;
        // Atom a;
        Fact f;
        index = 0;
        text = (s + "\0").toCharArray();
        switch (text[0]) {
            case 'l':
                r = rule();
                if (show) {
                    System.out.println(r.toString());
                }
                else if (rs != null) {
                    rs.AddRule(r);
                }
                break;
            case 'p':
                f = fact();
                if (show) {
                    System.out.print(f.toString());
                    System.out.println();
                }
                else if (rs != null) {
                    rs.AddFact(f.symbol, new GroundAtom(f.terms));
                }
                break;
            /*
             *  case 'x':
             *  r = xrule();
             *  if (show) {r.print(System.out); System.out.println();}
             *  else if (rs != null) rs.AddBaseRule(r);
             *  break;
             */
        }
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    boolean digit() {
        if (('0' <= text[index]) && ('9' >= text[index])) {
            return true;
        }
        else {
            return false;
        }
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    public Fact fact() throws SParseError {
        int sym;
        Atom a;
        // Term ts[];
        index++;
        sym = number();
        a = atom();
        return new Fact(sym, a.terms);
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    Head head() throws SParseError {
        Atom a;
        Head h;
        int sym;
        index++;
        sym = number();
        a = atom();
        h = new Head(sym, a.terms);
        return h;
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    int number() throws SParseError {
        Integer zahl;
        String s;
        int startindex;
        startindex = index;
        while (digit()) {
            index++;
        }
        s = new String(text, startindex, index - startindex);
//System.out.print("number: "); System.out.print(startindex); System.out.print(":");System.out.print(index); System.out.println(new String(text,startindex,index-startindex+1));
        try {
            zahl = new Integer(s);
        } catch (NumberFormatException p) {
            System.out.println(s);
            throw new SParseError("number expected");
        }
        return zahl.intValue();
    }


    /**
     *  Description of the Method
     *
     *@param  s  Description of the Parameter
     */
    public void ParseString(String s) {
        index = 0;
        text = (s + "\0").toCharArray();
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    public Rule rule() throws SParseError {
        int anzheads;
        int anzbodies;
        int i;
        Head heads[];
        Body bodies[];
        Rule r;
        index++;
        anzheads = number();
        heads = new Head[anzheads];
        index++;
        anzbodies = number();
        bodies = new Body[anzbodies];
        for (i = 0; i < anzheads; i++) {
            heads[i] = head();
        }
        for (i = 0; i < anzbodies; i++) {
            bodies[i] = body();
        }
        r = new Rule(heads, bodies);
        return r;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    boolean sign() {
        if ((text[index] == '+') || (text[index] == '-')) {
            return true;
        }
        else {
            return false;
        }
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    public Term term() throws SParseError {
        int anz = 0;
        int sym = 0;
        int i;
        String s = "";
        double zahl = 0.0;
        Term t = null;
        Term ts[];
        char ch = text[index++];
        switch (ch) {
            case 'c':
                sym = number();
                break;
            case 'n':
                zahl = Zahl();
                break;
            case '"':
                s = Zeichenkette();
                break;
            case 'X':
                sym = number();
                break;
        }
        if (text[index] == 'l') {
            index++;
            anz = number();
        }
        ts = new Term[anz];
        if (anz > 0) {
            ts = new Term[anz];
            // System.out.print("(");
            for (i = 0; i < anz; i++) {
                ts[i] = term();
                // if (i < anz-1) System.out.print(",");
            }
            // System.out.print(")");
        }
        switch (ch) {
            case 'c':
                t = new ConstTerm(sym, ts);
                break;
            case 'n':
                t = new NumTerm(zahl, ts);
                break;
            case '"':
                t = new StringTerm(s, ts);
                break;
            case 'X':
                t = new Variable(sym);
                break;
        }
        return t;
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    Rule xrule() throws SParseError {
        // int i;
        Head heads[];
        // Body bodies[];
        Rule r;
        int port = 1000;
        String host = "";
        index++;
        heads = new Head[1];
        heads[0] = head();
        index++;
        port = number();
        index++;
        host = Zeichenkette();
        // bodies = new Body[1];
        // bodies[0] = new Body(heads[0].symbol, false, heads[0].terms);
        r = new Rule(heads, null);
        r.external = true;
        r.host = host;
        r.port = port;
        return r;
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    double Zahl() throws SParseError {
        Double zahl;
        String s;
        int startindex;
        startindex = index;
        // Vorkommateil
        if (!digit() && !sign()) {
            throw new SParseError("+,- or digit expected");
        }
        if (sign()) {
            index++;
            if (!digit()) {
                throw new SParseError("digit expected");
            }
        }
        while (digit()) {
            index++;
        }
        // Nachkommateil
        if (text[index] == '.') {
            index++;
            while (digit()) {
                index++;
            }
        }
        // Exponent
        if ((text[index] == 'e') || (text[index] == 'E')) {
            index++;
            if (!sign() && !digit()) {
                throw new SParseError("+,- or digit expected");
            }
            else {
                if (sign()) {
                    index++;
                    if (!digit()) {
                        throw new SParseError("digit expected");
                    }
                }
                while (digit()) {
                    index++;
                }
            }
        }
        s = new String(text, startindex, index - startindex);
        try {
            zahl = new Double(s);
        } catch (NumberFormatException p) {
            throw new SParseError("number expected");
        }
        return zahl.doubleValue();
    }


    /**
     *  Description of the Method
     *
     *@return                  Description of the Return Value
     *@exception  SParseError  Description of the Exception
     */
    String Zeichenkette() throws SParseError {
        int startindex;
        String s;
        startindex = index;
        while ((text[index] != '"') && (text[index] != '\0')) {
            index++;
        }
        if (text[index] == '\0') {
            throw new SParseError("closing \" expected");
        }
        index++;
        try {
            s = new String(text, startindex, index - startindex - 1);
        } catch (StringIndexOutOfBoundsException p) {
            throw new SParseError("");
        }
        return s;
    }
}
