package org.semanticweb.triple.inference;
import org.semanticweb.lp.Term;

/*
 *  Name: SimpleSubst.java
 *  Version: 1.0
 *  Purpose:
 *  Represents simple answer substitutions returned from the
 *  inference engine
 *  History:
 *  3.5.99 created SDe
 */
/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class SimpleSubst {
    String Var;
    org.semanticweb.lp.Term Substitution;


    /**
     *  Constructor for the SimpleSubst object
     *
     *@param  Var           Description of the Parameter
     *@param  Substitution  Description of the Parameter
     */
    SimpleSubst(String Var, org.semanticweb.lp.Term Substitution) {
        this.Var = Var;
        this.Substitution = Substitution;
    }


    /**
     *  Gets the term attribute of the SimpleSubst object
     *
     *@return    The term value
     */
    public org.semanticweb.lp.Term getTerm() {
        return Substitution;
    }


    /**
     *  Gets the variable attribute of the SimpleSubst object
     *
     *@return    The variable value
     */
    public String getVariable() {
        return Var;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        return Var + " = " + Substitution.toString();
    }
}
