package org.semanticweb.triple.inference;


import java.io.*;
import java.util.*;

/**
 *  Description of the Class
 *
 *@author     Administrator
 *@created    January 17, 2002
 */
public class SymbolWrapper {
    /**
     *  Description of the Field
     */
    public String s;
    int references;
    int arity;


    /**
     *  Constructor for the SymbolWrapper object
     *
     *@param  s  Description of the Parameter
     */
    public SymbolWrapper(String s) {
        this.s = s;
        references = 0;
        arity = 0;
    }


    /**
     *  Constructor for the SymbolWrapper object
     *
     *@param  s      Description of the Parameter
     *@param  arity  Description of the Parameter
     */
    public SymbolWrapper(String s, int arity) {
        this.s = s;
        references = 1;
        this.arity = arity;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public boolean decreaseReference() {
        references = references - 1;
        return references <= 0;
    }


    /**
     *  Description of the Method
     *
     *@param  w  Description of the Parameter
     *@return    Description of the Return Value
     */
    public boolean equals(Object w) {
        if (w instanceof SymbolWrapper) {
            SymbolWrapper sw = (SymbolWrapper) w;
            return (this.arity == sw.arity) && (this.s.equals(sw.s));
        }
        return false;
    }


    /**
     *  Gets the arity attribute of the SymbolWrapper object
     *
     *@return    The arity value
     */
    public int getArity() {
        return arity;
    }


    /**
     *  Gets the reference attribute of the SymbolWrapper object
     *
     *@return    The reference value
     */
    int getReference() {
        return references;
    }


    /**
     *  Gets the symbol attribute of the SymbolWrapper object
     *
     *@return    The symbol value
     */
    public String getSymbol() {
        return s;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public int hashCode() {
        return s.hashCode();
    }


    /**
     *  Description of the Method
     */
    void increaseReference() {
        references++;
    }
}
