package org.semanticweb.triple.inference.builtins;

import java.io.*;
import java.lang.*;
import org.semanticweb.triple.inference.BuiltinFunc;

/**
 *  Copyright  Juergen Angele and Stefan Decker, Institut AIFB, University of
 *  Karlsruhe. All Rights Reserved.
 *
 *@author     Administrator
 *@created    January 17, 2002
 */

public class Builtin {
    String classid = null;
    /**
     *  Description of the Field
     */
    public BuiltinFunc builtinobject = null;
    /**
     *  Description of the Field
     */
    public String symbol;
    /**
     *  Description of the Field
     */
    public int arity;
    private Class c = null;


    /**
     *  Constructor for the Builtin object
     *
     *@param  symbol  Description of the Parameter
     *@param  arity   Description of the Parameter
     */
    Builtin(String symbol, int arity) {
        this.symbol = symbol;
        this.arity = arity;
    }


    /**
     *  Constructor for the Builtin object
     *
     *@param  symbol         Description of the Parameter
     *@param  arity          Description of the Parameter
     *@param  builtinobject  Description of the Parameter
     */
    public Builtin(String symbol, int arity, BuiltinFunc builtinobject) {
        this.builtinobject = builtinobject;
        this.symbol = symbol;
        this.arity = arity;
    }


    /**
     *  Constructor for the Builtin object
     *
     *@param  symbol   Description of the Parameter
     *@param  arity    Description of the Parameter
     *@param  classid  Description of the Parameter
     */
    public Builtin(String symbol, int arity, String classid) {
        this.classid = classid;
        this.symbol = symbol;
        this.arity = arity;
    }


    /**
     *  Gets the arity attribute of the Builtin object
     *
     *@return    The arity value
     */
    public int getArity() {
        return arity;
    }


    /**
     *  Gets the symbol attribute of the Builtin object
     *
     *@return    The symbol value
     */
    public String getSymbol() {
        return symbol;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public BuiltinFunc newInstance() {
        if (builtinobject != null) {
            return builtinobject;
        }
        /*
         *  uncomment  when a new object should be generated
         *  if(c==null)
         *  try{
         *  c = Class.forName(classid);
         *  } catch(Exception e){System.out.println("Wrong classID "+classid);}
         *  try{
         *  return (BuiltinFunc) c.newInstance();
         *  } catch(Exception e) { System.out.println("Can't instantiate " + c.toString()); return null;}
         */
        return null;
    }


    /**
     *  Description of the Method
     *
     *@return    Description of the Return Value
     */
    public String toString() {
        if (c != null) {
            return c.toString() + "/" + new Integer(arity);
        }
        else {
            return symbol + "/" + new Integer(arity);
        }
    }
}
