package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


public class And extends BinaryFormula {
  
  public String toString(Syntax syntax) {
    StringBuffer buffer = new StringBuffer();
    if (model != null)
      buffer.append("("); // or always () ... ??
    buffer.append(firstFormula.toString(syntax));
    buffer.append(syntax.getAnd());
    buffer.append(secondFormula.toString(syntax));
    if (model != null) {
      buffer.append(")");
      appendModel(syntax, buffer);
    }
    return buffer.toString();
  }
  
  public GLogicFormula toGLP(GLPTerm model) {
    ArrayList glpFormulae = new ArrayList();
    model = overrideModel(model, this.model, glpFormulae);
    GLPAnd glpAnd = 
      new GLPAnd(firstFormula.toGLP(model), secondFormula.toGLP(model));
    return makeGLPConjunction(glpFormulae, glpAnd);
  }
  
  // static auxiliaries
  
  public static GLogicFormula makeGLPConjunction(ArrayList conjucts) {
    return makeGLPConjunction(conjucts, null);
  }
  
  public static GLogicFormula makeGLPConjunction(ArrayList conjuncts,
      GLogicFormula conjunct) {
    // makes a big conjuction
    if (conjuncts == null || conjuncts.size() == 0)
      return conjunct;
    else {
      GLogicFormula conjunction;
      int pos = conjuncts.size()-1;
      if (conjunct == null) {
        conjunction = (GLogicFormula)conjuncts.get(pos);
        pos--;
      } else {
        conjunction = conjunct;
      }
      for (int i = pos; i >= 0; i--) {
        GLogicFormula formula = (GLogicFormula)conjuncts.get(i);
        conjunction = new GLPAnd(formula, conjunction);
      }
      return conjunction;
    }
  }  
  

}
