package org.semanticweb.triple.language;

import java.util.*;
import org.semanticweb.glp.*;


public class Triple extends Atom {

  Term subject;
  Term predicate;
  Term object;

  public void putSubject(Term subject) { this.subject = subject; }
  public void putPredicate(Term predicate) { this.predicate = predicate; }
  public void putObject(Term object) { this.object = object; }
  public void putObject(String objectString) { // we need this everywhere!
    this.object = new Literal(objectString);
  }

  public Term getSubject() { return subject; }
  public Term getPredicate() { return predicate; }
  public Term getObject() { return object; }

  public String toString(Syntax syntax) {
    StringBuffer buffer = new StringBuffer();
    buffer.append(subject.toString(syntax));
    buffer.append("[");
    buffer.append(predicate.toString(syntax));
    buffer.append("->");
    buffer.append(object.toString(syntax));
    buffer.append("]");
    appendModel(syntax, buffer);
    return buffer.toString();
  }

  /*
  public TripleExpression toHornLogic(Context context) {
    // s[p->o] -> true(triple(s',p',o'), model)
    HornAtom trueAtom = new HornAtom();
    trueAtom.putPredicateSymbol("true");
    // this -> triple struct
    Structure struct = new Structure();
    struct.putFunctor("triple");
    Term model = this.getModel();
    if (model != null)
      context = context.clone(model);
    struct.putArgs((Term)subject.toHornLogic(context));
    struct.putArgs((Term)predicate.toHornLogic(context));
    struct.putArgs((Term)object.toHornLogic(context));
    trueAtom.putArgs(struct);
    trueAtom.putArgs(context.getDefaultModel());
    return trueAtom;
  }
  */
  
  /*
  public GLPExpression toGLP(Context context) {
    // s[p->o] -> true(triple(s',p',o'), model)
    // this -> triple struct
    Term model = this.getModel();
    if (model != null)
      context = context.clone(model);
    ArrayList structargs = new ArrayList(3);
    structargs.add(subject.toGLP(context));
    structargs.add(predicate.toGLP(context));
    structargs.add(object.toGLP(context));
    GLPTermFunction struct = new GLPTermFunction("triple", structargs);
    ArrayList trueargs = new ArrayList(2);
    trueargs.add(struct);
    trueargs.add(((Term)context.getDefaultModel()).toGLP(context));
    GLPAtom trueAtom = new GLPAtom("true", trueargs);
    return trueAtom;
  }
  */
  
  public GLogicFormula toGLP(GLPTerm model) {
    return null; // at the moment, only Molecule is used !!!
  }
  
}
