/*
 * Syntax.java
 *
 * Created on February 7, 2002, 2:45 PM
 */

package org.semanticweb.utilities;

/**
 * Some static auxiliary functions for PROLOG-like syntaxes.
 * @author  Michael Sintek
 * @version 
 */
public class SyntaxHelper {

  public static String symbol(String name, boolean prolog) {
    // add quotes if necessary (-> PROLOG symbol)
    if (name == null || name.equals(""))
      return "''";
    StringBuffer buffer = new StringBuffer();
    boolean quotesNeeded = false;
    for (int i = 0; i < name.length(); i++) {
      char c = name.charAt(i);
      buffer.append(c);
      if (c == '\'') buffer.append('\'');
      if (!(Character.isLetterOrDigit(c) || c  == '_'))
	quotesNeeded = true;
    }
    if (prolog && !quotesNeeded) { // check if it looks like a PROLOG variable
      char c = name.charAt(0);
      if (Character.isUpperCase(c) || c == '_')
	quotesNeeded = true;
    }
    if (quotesNeeded)
      return "'" + buffer.toString() + "'";
    else
      return name; // buffer.toString()
  }
  
  public static String prologVariable(String name) {
    if (name == null || name.equals(""))
      return "_";
    else {
      char c = name.charAt(0);
      if (Character.isUpperCase(c) || c == '_')
        return name; // normalize
      else
        return "_" + name; // normalize
    }
  }

}
